#!/usr/bin/perl
#--NetShopOwner-CGI-version:4.2.5.5--

;#
;# order1.cgi
;# [PC]ҏ͉
;# Copyright (c) 2004- Increment P Corp. All rights reserved.
;#
;# 2009/09/30 NSO4Ή
;# 2010/05/11 Y.motai SBPSϑΉ
;# last modified 2011/11/24 Y.motai yVJ[hϑΉ
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use Design::TemplOrder1;
use Lib::SiteStatus;
use Lib::ExpensesGoods;
use Lib::StockUtil;
use Digest::MD5 'md5_hex';

&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# 2010/05/12 T.Hinohara start
# SBPSĂ΂ꂽꍇAPOSTƂȂ邪A
# ꕔp[^URLɕtĂ邽߁A
# ʓr擾Kv
if ($ENV{REQUEST_METHOD} eq 'POST'){
	# ϐCGIURLɕtĂGETp[^擾B
	my $buffer = $ENV{QUERY_STRING};
	# [&]؂IDID𕪊
	my @pairs = split( /&/, $buffer );
	foreach my $pair ( @pairs ) {
		my ( $name, $value ) = split( /=/, $pair );
		%in->{$name} = $value;
	}
}
# 2010/05/12 T.Hinohara end

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();
my $NsoMisc       = NsoMisc->new();
my $LibStockUtil = Lib::StockUtil->new();
my $ExpensesGoods;

my $SamePeriodID    = "";	# ID
my $PossessionPoint = 0;	# ۗL|Cg
my $PointExpireDate = "";	# |CgL

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $status_err;

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
		login      => \&login,
		logged_in  => \&logged_in,
	);
	&check_order_finish;
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}
exit();

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing();
}

;#
;# C
;#
sub main {
	if ( $SamePeriodID eq "" ) {
		# @\gpL/ݒ擾
		my $memberUseFlag      = $ConfigMaster{adm_member_master}{member}{UseFlag};
		my $memberSubscription = $ConfigMaster{adm_member_master}{member}{Subscription};
		# @\gp  ̂ݍw\ȏꍇAJ[gʂ
		if ( $memberUseFlag == 1 and $memberSubscription == 1 ) {
			&redirectBasketUrl({ ErrorStatus=>'only_member_service' });
		}
	}

	# iEoZ
	my $isMember = ( $SamePeriodID eq "" )? 0: 1;
	$ExpensesGoods = Lib::ExpensesGoods->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster,
                                               IsMember=>$isMember, 					# tO
                                               PossessionPoint=>$PossessionPoint,		# ۗL|Cg
                                               PointExpireDate=>$PointExpireDate });	# |CgL

	my $eg_err = $ExpensesGoods->ParseBasket();

	# G[bZ[W擾
	$status_err = &error_message( $in{ErrorStatus} );

	if($eg_err ne ""){
		$status_err .= $eg_err;
	}

	# VXeev[gNXCX^X
	my $TemplOrder1 = Design::TemplOrder1->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, KickBack=>$in{KickBack}, ExpensesGoods=>$ExpensesGoods, status_err=>$status_err, Query=>\%in, SamePeriodID=>$SamePeriodID });
	
	# ue
	my $contents = $TemplOrder1->RelpaceSystemTempl();
	
	# VXeev[gu
	print $NsoMisc->print_header();
	print $contents;
	exit();
}

;#
;# iPCOSS`FbN
;#
sub check_order_finish {

	# IDNbL[ǂݎ
	require DB::NsoOrderIDDB;
	my $OrderIdDB = NsoOrderIDDB->new();
	my $OrderID   = $OrderIdDB->Read_OrderID();

	# IDNbL[cĂꍇ
	if ($OrderID ne ""){
		require Lib::IpcossCheck;
		my $IpcossCheck = Lib::IpcossCheck->new( {ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, ExpensesGoods=>$ExpensesGoods} );
		# ipcoss ChecksB
		my $IpcCheckFlag = $IpcossCheck->check_ipcoss();
		# okng̏ꍇ̏
		if ($IpcCheckFlag eq 0){
			# ngƂ̏
			$IpcossCheck->ipcoss_ng();
		} else {
			# ok Ƃ̏
			my $contents = $IpcossCheck->RelpaceSystemTempl();
			print $NsoMisc->print_header();
			print $contents;
			exit ();
		}
	}
}

;#
;# OCsĉw
;#
sub login {

	# @\gpL擾
	my $memberUseFlag = $ConfigMaster{adm_member_master}{member}{UseFlag};

	# @\gp̏ꍇAJ[gʂ
	if ( $memberUseFlag == 0 ) {
		&redirectBasketUrl({ ErrorStatus=>'no_member_service' });
	}

	# 擾 (MailAddress,Password)
	my $mailAddress = $in{MailAddress};
	my $passWord    = $in{PassWord};
	
	# pX[hMD5nbV
	$passWord = md5_hex $passWord;
	
	require DB::NsoMemberDB;
	my $MemberDB = NsoMemberDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	if ( $MemberDB->{resultDbConnect} ne "" ) {
		&redirectBasketUrl({ ErrorStatus=>'db_access_error101' });
	}
	my %resultMemberDB = $MemberDB->Member_Select_Mail_Pwd_Query({ MailAddress=>$mailAddress , Password=>$passWord });
	if ( $resultMemberDB{status_err} ne "" ) {
		&redirectBasketUrl({ ErrorStatus=>'db_access_error102' });
	}
	
	# 񂪑݂ȂꍇAJ[gʂ
	if ( $resultMemberDB{RecordCount} == 0 ) {
		&redirectBasketUrl({ ErrorStatus=>'login_error' });
	}
	my %recMember = %{$resultMemberDB{RecordList}};

	# 敪F҂̏ꍇAJ[gʂ
	unless ( $recMember{MemberFlag} == 3 ) {
		&redirectBasketUrl({ ErrorStatus=>'no_approval_member' });
	}

	my $samePeriodID = $recMember{SamePeriodID};
	
	# OC擾
	require DB::NsoLoginTempDB;
	my %where   = ( LoginTempID=>1 );
	my %records = ( SamePeriodID=>$samePeriodID );
	my $LoginTempDB = NsoLoginTempDB->new();
	$LoginTempDB->load_data_no_lock({ where=>\%where });
	if ( $LoginTempDB->{RecordCount} > 0 ) {
		# OCXV
		$LoginTempDB->update_no_lock({ records=>\%records });
	} else {
		# OCǉ
		$LoginTempDB->insert_no_lock({ records=>\%records });
	}
	
	&logged_in();
};

;#
;# ݃OC̉ŉw
;#
sub logged_in {
	my $samePeriodID = "";
	
	# @\gpL擾
	my $memberUseFlag = $ConfigMaster{adm_member_master}{member}{UseFlag};

	# @\gp̏ꍇAJ[gʂ
	if ( $memberUseFlag == 0 ) {
		&redirectBasketUrl({ ErrorStatus=>'no_member_service' });
	}

	# OC擾
	require DB::NsoLoginTempDB;
	my %where = ( LoginTempID=>1 );
	my $LoginTempDB = NsoLoginTempDB->new();
	$LoginTempDB->load_data_no_lock({ where=>\%where });

	# OC񂪑݂ȂꍇAJ[gʂ
	if ( $LoginTempDB->{RecordCount} == 0 ) {
		&redirectBasketUrl({ ErrorStatus=>'logged_in' });
	}

	my @arrLoginTemp = @{$LoginTempDB->{RecordList}};
	my %recLoginTemp = %{$arrLoginTemp[0]};
	$samePeriodID = $recLoginTemp{SamePeriodID};

	# 擾 (SamePeriodID)
	require DB::NsoMemberDB;
	my $MemberDB = NsoMemberDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	if ( $MemberDB->{resultDbConnect} ne "" ) {
		&redirectBasketUrl({ ErrorStatus=>'db_access_error101' });
	}
	my %resultMemberDB = $MemberDB->Member_Select_ID_Query({ SamePeriodID=>$samePeriodID });
	if ( $resultMemberDB{status_err} ne "" ) {
		&redirectBasketUrl({ ErrorStatus=>'db_access_error103' });
	}
	
	# 񂪎擾łȂꍇAJ[gʂ
	if ( $resultMemberDB{RecordCount} == 0 ) {
		&redirectBasketUrl({ ErrorStatus=>'logged_in_error' });
	}
	my %recMember = %{$resultMemberDB{RecordList}};
	# 敪F҂̏ꍇAJ[gʂ
	unless ( $recMember{MemberFlag} == 3 ) {
		&redirectBasketUrl({ ErrorStatus=>'logged_in_no_approval_member' });
	}
	
	# OCXV(ŏIXVύX̂)
	$LoginTempDB->update_no_lock(\%recLoginTemp);
	
	# Cookie̗LXV
	$LoginTempDB->update_expiration_cookie();
	
	# IDێ
	$SamePeriodID = $samePeriodID;
	# ۗL|Cgێ
	$PossessionPoint = $recMember{Point};
	# |CgLێ
	$PointExpireDate = $recMember{PointExpireDate};
	
	&main();
}

;#
;# J[gʂփ_CNg
;#
sub redirectBasketUrl {
	my ($queryHash) = shift if @_;
	
	# J[gʃy[WURL
	my $basketUrl = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{basket};
	# SSL󋵂ɉURLu
	$basketUrl = $NsoMisc->getChangedURL({url=>$basketUrl, key=>'AfterCart'});

	my $queryString = $NsoMisc->make_query_string($queryHash, 'get');

	print $NsoMisc->redirect(join("", $basketUrl, $queryString));
	exit();
}

;#
;# G[bZ[W擾
;#
sub error_message {

	my %ErrorMessageHash = (
		login_error			=> qq([AhXA܂̓pX[hԈĂ܂B<br>),
		no_approval_member	=> qq(Ǘ҂ɂFĂ܂B<br>),
		logged_in			=> qq(OC̗L߂Ă܂BēxOCĂB<br>),
		no_member_service	=> qq(݁AT[rX͎gpł܂B<br>),
		only_member_service	=> qq(wł܂B<br>),
		db_access_error		=> qq(VXeG[܂BVXeǗ҂ɘAĂB<br>),
		
		# TemplOrder3 #redirectOrder1Url()
		err_TemplOrder3_001 => qq(N[|擾ł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
		err_TemplOrder3_002 => qq(N[|ID̓͂Ɍ肪܂B<br>),
		err_TemplOrder3_003 => qq(N[|擾ł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
		err_TemplOrder3_004 => qq(͂ꂽN[|ID́AłɎgpĂ܂B܂AN[|ID͂llɂx݂̂̂gpƂĂĂ܂B<br>),
		err_TemplOrder3_005 => qq(܂A͂ꂽN[|ID́Agp߂Ă邽߁Agp܂B<br>),
		err_TemplOrder3_006 => qq(܂A͂ꂽN[|ID́AivzsĂ邽߁Ap܂B<br>),
		err_TemplOrder3_007 => qq(葱̊ԂɁA|Cg̕ύXs܂B<br>萔łAxsĂB<br>),
#		err_TemplOrder3_008 => qq(ۗ̕L|CgXVA|Cggpۗ̕L|Cg0ɂȂ<br>),
		err_TemplOrder3_009 => qq(f[^x[X֐ڑł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
#		err_TemplOrder3_010 => qq(ۗ̕L|CgXVA̎擾Ɏs<br>),
#		err_TemplOrder3_011 => qq(ۗ̕L|CgXVA񂪑݂Ȃ<br>),
		err_TemplOrder3_012 => qq(|CgXVł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
		err_TemplOrder3_013 => qq(N[|XVł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
		err_TemplOrder3_014 => qq(VXeG[܂BxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
		err_TemplOrder3_015 => qq(f[^x[XG[܂BxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹B<br>),
		
		# SBPSϗpG[R[h(Order1Ƀ_CNgn)
		err_SbpsPayInfo_001 => qq(N[|擾ł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_002 => qq(N[|ID̓͂Ɍ肪܂Bisbps_errorj<br>),
		err_SbpsPayInfo_003 => qq(N[|擾ł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_004 => qq(͂ꂽN[|ID́AłɎgpĂ܂B܂AN[|ID͂llɂx݂̂̂gpƂĂĂ܂Bisbps_errorj<br>),
		err_SbpsPayInfo_005 => qq(܂A͂ꂽN[|ID́Agp߂Ă邽߁Agp܂Bisbps_errorj<br>),
		err_SbpsPayInfo_006 => qq(܂A͂ꂽN[|ID́AivzsĂ邽߁Ap܂Bisbps_errorj<br>),
		err_SbpsPayInfo_007 => qq(葱̊ԂɁA|Cg̕ύXs܂B<br>萔łAxsĂBisbps_errorj<br>),
		err_SbpsPayInfo_009 => qq(f[^x[X֐ڑł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_012 => qq(|CgXVł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_013 => qq(N[|XVł܂łBxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_014 => qq(VXeG[܂BxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_015 => qq(f[^x[XG[܂BxsĂB<br>ēxÃbZ[W\\ꍇ́A萔łAVbv^c҂ւ₢킹Bisbps_errorj<br>),
		err_SbpsPayInfo_016 => qq(SBPSςɊ܂łB<br>ʁFNG ($in{ErrorCode})isbps_errorj),
		err_SbpsPayInfo_017 => qq(SBPSςɊ܂łB<br>ʁFAR,CRisbps_errorj),
		err_SbpsPayInfo_018 => qq(SBPSςɊ܂łB<br>ʁFsisbps_errorj),
		err_SbpsPayInfo_019 => qq(SBPSςɊ܂łB<br>`FbNTlsłBisbps_errorj),
		err_SbpsPayInfo_020 => qq(ϕ@ݒ肳Ă܂B<br>X܊Ǘ҂͌ϕ@̐ݒemFBisbps_errorj),
		err_SbpsPayInfo_021 => qq(SBPSςɊ܂łB<br>zlsłBisbps_errorj),
		err_SbpsPayInfo_022	=> qq(SBPSςɊ܂łB<br>܂AēxsĂBisbps_errorj),
		
		# yVJ[hpG[R[h(Order1Ƀ_CNgn)
		NG => qq(yVJ[hςɊ܂łB<br>ʁFNG ($in{ErrorCode})irakuten_errorj),
		CN => qq(\\LZ܂B<br>ʁFCNirakuten_errorj),
	);

	my $error_code = shift @_;
	return ( exists $ErrorMessageHash{$error_code} )? $ErrorMessageHash{$error_code}: qq();
}












